package com.jeremyparsons.imaging;

import java.awt.image.BufferedImage;
import java.awt.image.PackedColorModel;

/**
 Not used currently.
 */
public final class ImageFilters {
	/*
	Do a controlled blur over the whole image
	*/
	static void selectiveBlurFilter(BufferedImage inImage, BufferedImage blurredImage){
		int lastX = inImage.getWidth() - 1;
		int lastY = inImage.getHeight() - 1;
		int newRGB = 0;
		
		// Copy bottom edge
		for (int x = lastX; x >= 0; x--){
			blurredImage.setRGB(x, lastY, inImage.getRGB(x, lastY));
			}
		// Do blurring
		for (int y = (lastY - 1); y > 0; y--){
			blurredImage.setRGB(lastX, y, inImage.getRGB(lastX, y));
			for (int x = (lastX - 1); x > 0; x--){
				newRGB = leastGreenLineBlur(x, y, inImage);
				blurredImage.setRGB(x, y, newRGB);
				}
			blurredImage.setRGB(0, y, inImage.getRGB(0, y));
			}
		// Copy top edge
		for (int x = lastX; x >= 0; x--){
			blurredImage.setRGB(x, 0, inImage.getRGB(x, 0));
			}
		}
	/**
	Use the green channel (Median frequency) to find mean value from neighbouring
	pixels in each of four directions. Then find line mean that is closest
	to the current value, and force all channels to mean of current and 
	line means for each channel.
	
        Should add some kind of brightness scaling so only darker areas get full averaging.	
	*/
	static int leastGreenLineBlur (int x, int y, BufferedImage image){
		PackedColorModel colorModel = (PackedColorModel)image.getColorModel();
		int currPix = image.getRGB(x, y);
		int currGreen = colorModel.getGreen(currPix);
		final int[] neighbours = new int[8];

		int index = 0;
		neighbours[index++] = image.getRGB(x, y - 1);		// North
		neighbours[index++] = image.getRGB(x + 1, y - 1);	// North East
		neighbours[index++] = image.getRGB(x + 1, y);
		neighbours[index++] = image.getRGB(x + 1, y + 1);
		neighbours[index++] = image.getRGB(x, y + 1);		// South (North + 4)
		neighbours[index++] = image.getRGB(x - 1, y + 1);	// South West 
		neighbours[index++] = image.getRGB(x - 1, y);
		neighbours[index++] = image.getRGB(x - 1, y - 1);
	
		int minDiff = 255;
		int minDiffIndex = -1;
		int tempDiff = 0;
		int[] greenLineMeans = new int[4];
		for (int i = 0; i < 4; i++){
			greenLineMeans[i] = (colorModel.getGreen(neighbours[i]) + (colorModel.getGreen(neighbours[i + 4]))) >>> 1;
			tempDiff = Math.abs(greenLineMeans[i] - currGreen);
			if (tempDiff < minDiff){ // Note implicit bias to North South, then clockwise against NW->SE
				minDiff = tempDiff;
				minDiffIndex = i;
				}
			}
		// System.err.println("MDI=" + minDiffIndex + " MD=" + minDiff);

		int blurred = 0;
		int masks[] = colorModel.getMasks();
		int neighbourMean = 0;
		for (int maskIndex = 0; maskIndex <= 2; maskIndex++){
			int currMask = masks[maskIndex];
			int currValue = currPix & currMask;
			int newValue = 0;
			// blurred = blurred | (currPix & currMask);
			neighbourMean = (((neighbours[minDiffIndex]) & currMask) +
				((neighbours[minDiffIndex + 4]) & currMask) >>> 1) & currMask;
			newValue = (((currValue + neighbourMean) >>> 1) & currMask);
			/*
			if (((Math.abs(newValue - currValue)) > 10) && (currValue < 255)){
				System.err.println("currValue=" + currValue +
					" newValue=" + newValue +
					" neighbourMean=" + neighbourMean);
				}
			*/
			blurred = blurred | newValue;
			}
		/*
		if (blurMonitoring){
			int newRed, oldRed;
			int newGreen, oldGreen;
			int newBlue, oldBlue;

			blurStats.count++;
			oldRed = colorModel.getRed(currPix);
			newRed = colorModel.getRed(blurred);
			blurStats.red += Math.abs(oldRed - newRed);

			oldGreen = colorModel.getGreen(currPix);
			newGreen = colorModel.getGreen(blurred);
			blurStats.green += Math.abs(oldGreen - newGreen);

			oldBlue = colorModel.getBlue(currPix);
			newBlue = colorModel.getBlue(blurred);
			blurStats.blue += Math.abs(oldBlue - newBlue);
			// System.err.println("DEBUG oldRed=" + oldRed + " newRed=" + newRed + " oldGreen=" + oldGreen + " newGreen=" + newGreen +" oldBlue=" + oldBlue + " newBlue=" + newBlue);
			}
			*/

		return(blurred);
		}
}
