package com.jeremyparsons.imaging;
// import static org.imgscalr.Scalr.OP_ANTIALIAS;
// import static org.imgscalr.Scalr.OP_BRIGHTER;
//import static org.imgscalr.Scalr.Method.ULTRA_QUALITY;
//  import static org.imgscalr.Scalr.Method.QUALITY;


import java.awt.image.BufferedImage;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.imageio.IIOImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriter;
import javax.imageio.ImageTypeSpecifier;
import javax.imageio.metadata.IIOMetadata;
import javax.imageio.plugins.jpeg.JPEGImageWriteParam;
import javax.imageio.stream.ImageOutputStream;

import org.imgscalr.Scalr.Method;
import org.w3c.dom.Element;

public class ImageUtil {

	public static void saveAsJPEG(String jpgFlag, BufferedImage outImage, float JPEGcompression, FileOutputStream fos) throws IOException {

		//useful documentation at http://docs.oracle.com/javase/7/docs/api/javax/imageio/metadata/doc-files/jpeg_metadata.html
		//useful example program at http://johnbokma.com/java/obtaining-image-metadata.html to output JPEG data
		// Image writer
		ImageWriter jpegWriter = ImageIO.getImageWritersBySuffix("jpeg").next();
		ImageOutputStream ios = ImageIO.createImageOutputStream(fos);
		jpegWriter.setOutput(ios);

		// metadata
		//IIOMetadata imageMetaData = imageWriter.getDefaultImageMetadata(new ImageTypeSpecifier(outImage), null);
		
		/*
		if (jpgFlag != null){
			int dpi = 96;
			try {
				dpi = Integer.parseInt(jpgFlag);
			} catch (Exception e) {
				e.printStackTrace();
			}
			//new metadata: javax.imageio.metadata.IIOMetadata
			Element tree = (Element) imageMetaData.getAsTree("javax_imageio_jpeg_image_1.0?");
			Element jfif = (Element)tree.getElementsByTagName("app0JFIF").item(0);
			jfif.setAttribute("Xdensity",Integer.toString(dpi));
			jfif.setAttribute("Ydensity", Integer.toString(dpi));

		} */

		if(JPEGcompression>=0 && JPEGcompression<=1f){
			JPEGImageWriteParam jpegParams = (JPEGImageWriteParam) jpegWriter.getDefaultWriteParam();
			jpegParams.setCompressionMode(JPEGImageWriteParam.MODE_EXPLICIT);
			jpegParams.setCompressionQuality(JPEGcompression);
			//imageWriter.write(imageMetaData, new IIOImage(outImage, null, null), null);
			jpegWriter.write(null, new IIOImage(outImage, null, null), jpegParams);
			}

		ios.close();
		jpegWriter.dispose();
	}
	
	/** 
	Never returns a scale greater than 1.0 because image expansion increases memory use without increasing quality.
	*/
	static float getScaleFactor(BufferedImage image, int desiredWidth, int desiredHeight){
		float imageX = (float)image.getWidth();
		float imageY = (float)image.getHeight();
		float maxX = (float)desiredWidth;
		float maxY = (float)desiredHeight;

		float scaleX = maxX / imageX;
		float scaleY = maxY / imageY;
		float scaleBoth = (scaleX < scaleY) ? scaleX : scaleY;
		scaleBoth = (scaleBoth > 1.0 ) ? 1.0F : scaleBoth;
		
		return(scaleBoth);
		}
}
